<template>
  <q-layout>
    <q-page-container>
      <q-page v-if="product" class="bg-grey-3">
        <div class="container breadcrumb bg-grey-4">
          <div class="q-py-md">
            <router-link to="/">Trang chủ</router-link>
            <span class="splitter">/</span>
            <router-link :to="`/category/${product.category.id}`">{{product.category.name}}</router-link>
            <span class="splitter">/</span>
            <router-link :to="`/brand/${product.brand.id}`">{{product.brand.name}}</router-link>
            <span class="splitter">/</span>
            <span class="endpoint">{{product.name}}</span>
          </div>
        </div>
        <div class="container bg-white">
          <div class="row q-col-gutter-md q-pb-md">
            <div class="col-12 col-md-6">
              <product-list-medias :product="product" />
            </div>
            <div class="col-12 col-md-6">
              <div class="text-h5 text-bold">{{product.name}}</div>
              <div class="flex q-my-md">
                <div class="q-mr-lg">
                  Thương hiệu:
                  <router-link
                    class="text-primary text-bold"
                    :to="`/brand/${product.brand.id}`"
                  >{{product.brand.name}}</router-link>
                </div>
                <div>
                  Danh mục:
                  <router-link
                    class="text-primary text-bold"
                    :to="`/category/${product.category.id}`"
                  >{{product.category.name}}</router-link>
                </div>
              </div>
              <div
                class="text-grey-7 q-pb-md q-mb-md"
                style="border-bottom: 1px solid rgba(0,0,0,0.1)"
              >Mã hàng: {{product.sku}}</div>
              <!-- Price -->
              <div class="q-pb-md q-mb-md" style="border-bottom: 1px solid rgba(0,0,0,0.1)">
                <div class="q-mb-md">
                  Giá:
                  <span class="text-h5 text-bold text-primary">{{product.price | money}}</span>
                </div>
                <div class="flex q-gutter-md items-center">
                  <div class="flex items-center">
                    <q-btn
                      dense
                      size="sm"
                      color="secondary"
                      icon="remove"
                      @click="decreaseQuantity"
                    />
                    <q-input
                      dense
                      type="number"
                      v-model.number="quantity"
                      outlined
                      class="q-mx-md quantity"
                    />
                    <q-btn dense size="sm" color="secondary" icon="add" @click="quantity += 1" />
                  </div>
                  <q-btn color="secondary" label="Thêm vào giỏ hàng" @click="submitAddToCart" />
                </div>
              </div>
              <!-- End Price -->
              <div v-html="descriptionDecoded(product.shortDescription)"></div>
            </div>
          </div>
        </div>
        <div class="bg-grey-2 container">
          <div class="q-py-md text-uppercase text-h6 text-bold">Mô tả sản phẩm</div>
        </div>
        <div class="bg-white container">
          <div class="q-py-md" v-html="descriptionDecoded(product.description)"></div>
        </div>
      </q-page>
    </q-page-container>
  </q-layout>
</template>

<script>
import { mapActions } from 'vuex';
import ProductListMedias from '~/components/user/ProductListMedias.vue';
import { CommonUtils } from '~/utils';

export default {
  components: { ProductListMedias },
  meta() {
    return {
      title: `${this.product ? this.product.name : ''} - Viet Distribution`
    };
  },
  data() {
    return {
      product: null,
      quantity: 1
    };
  },
  async mounted() {
    if (this.$route.params) {
      this.product = await this.getProductById(this.$route.params.id);
    }
  },
  methods: {
    ...mapActions({
      getProductById: 'products/getProductById',
      addToCart: 'cart/addToCart'
    }),
    decreaseQuantity() {
      if (this.quantity > 1) {
        this.quantity -= 1;
      }
    },
    submitAddToCart() {
      if (this.quantity > 0) {
        this.addToCart({ itemId: this.product.id, quantity: this.quantity });
      }
    },
    descriptionDecoded(description) {
      return CommonUtils.decodeHtml(description);
    }
  }
};
</script>

<style lang="scss" scoped>
.breadcrumb {
  margin-bottom: 16px;

  a {
    color: $primary;
    font-weight: bold;
    text-decoration: none;
  }

  .splitter {
    display: inline-block;
    margin: 0 10px;
  }
}
.quantity {
  width: 80px;

  /deep/ input {
    text-align: center;
  }
}
</style>
